Changes in version 3.19 ('Lucia')
==============================

  Support for pause/resume/quit when retyping file

  Defaults to use data display for all X.org with minor version nr >= 3

  New options:

      --record-from-data-display,-rfdd 
        Record from data display. This option is experimental.

      --record-from-control-display,-rfcd 
        Record from control display. This option is experimental.


Changes in version 3.18 ('Abbado')
==============================

  Removed incorrect comments.

Changes in version 3.17 ('Seeger')
==============================

  * New features:

  * Fixed bugs:

    Savannah:
    Mayhem:    #715746 "cnee crashes with exit status 139"
    Works with X.org 1.14.*


Changes in version 3.16
==============================

  * New features:

    Gnee can record XInput events

  * Fixed bugs:

    Savannah:


Changes in version 3.15
==============================

  * Fixed bugs:

    Savannah:
      bug #36662: 2 extra lines, not really needed, printed to recorded log files
      bug #37895: pnee/data/pnee.server.in file missing in 3.14 tarball?


Changes in version 3.14
==============================

  If XInput is present, record only XI events (discard core events).
  Forced core replay is now done using XI events (if no core events are 
available).

  * Fixed bugs:

    Bug-xnee mailing list: “WARNING: Enough valuators … still not printing”

Changes in version 3.13
==============================

   If XInput is present, record only XI events (discard core events).
   Forced core replay is now done using XI events (if no core events are available).

   * Fixed bugs:

     Bug-xnee mailing list:
        WARNING: Enough valuators ... still not printing

     

Changes in version 3.12
==============================

   * New option: --record-replay, -rr
        Record and replay a session (press q to stop recording)

   * Fixed bugs:

     Savannah
        bug #35029, Segmentation fault when using stop...

Changes in version 3.11
==============================

   * Fixed bugs:

     bug-xnee@gnu.org: Package of Xnee for Fedora
           Replaced exit calls with return in libxnee

     Savannah: 
       #30137: gnee crashes on Ubuntu 10.04

     Recording in X.org > 1.11 does not work 

     Fedora / Red Hat Bugzilla – Bug 757733

     Mem error when distributing to multiple displays
     

Changes in version 3.10
==============================

   * Fixed bugs:

     Savannah: 
        #33237, Xnee fails to record on RedHat
        #33667, Seg fault (on Ubuntu 11.04)
        #32385: CNEE replay precision
        #32767: Button key to stop recoring
        #32762: no sync option faulty


Changes in version 3.09
==============================

   * Fixed bugs:

     Savannah: 
        #31231: Replay in demo mode malfunctions
        #28238: XI2 extension support
	#28431: Separate tests needing a running X server
	#32291: Xnee fails checking gtk.h
  	#28242: Missing makeinfo dep in configure

     xnee-devel mailing list:
        cnee loves Xephyr ? 
           lists.gnu.org/archive/html/xnee-devel/2011-02/msg00000.html

     Debian bug report:
         # 613237 "3.08 is available which works fine in unstable"

Changes in version 3.08 
==============================

NEW in this release
   * Various fixes to make Xnee work with new versions
     of RECORD extension


Changes in version 3.07 
==============================

   * New features:
      Supports recording xnd replaying of XInput device events
        * Forced replaying of X11 core events can be done
        * Backward compatible with olde session files

     Experimental and undocumented features (read the source): 
        * replay backend
        * xswine - new swinput backend for Xnee

   * Build changes:

      --enable-man
      Checks for makeinfo once, uses result many times
      Can build guis and manual without all doc stuff

      --disable-xinput2
      By default Xnee is built with XI support

      Looks for gtk-config when configuring
      Checks for makeinfo once, uses result many times
      Can build guis and manual without all doc stuff


   * Issues
      Human printout of X Input events needs more work
      Need to make X Input code be totally ifdefed away

   * New options:
	--force-core-replay,-fcr 
          Discard recorded X Input device data, 
          use recorded core device data

        --disable-xinput-events
          Disable recording of XInput events

   * Fixed bugs as reported on ubuntuforums:
     http://ubuntuforums.org/showthread.php?t=1253453&highlight=xnee

     savannah bug: #30134 "Missing xnee.xpm in gnee"
     savannah bug: #30136 "Configure misses to check for gnome.h"

     Reported problems on N900 are fixed

    * Patches from Tuukka Pasanen, Fabian Keil


Changes in version 3.06 ('Dio')
==============================

   * New logo:
       pixmap/512x512/xnee-new.png

   * Build changes:
       configure bails out when building any gui 
       and no pkg-config installed

   * Test changes:
       Separated tests:
       * make check  - does not need an X server to connect to
       * make xcheck - needs an X server to connect to

   * Fixed bugs as reported on bug-xnee@gnu.org:
       "crash in xnee_key2string when verbose"
       "cnee causing segfault"

   * New options: 
        --no-reparent-recording

   * Options that didn't make it: 
        --force-reparent-recording

Changes in version 3.05 ('Merry X11-mas')
==============================

   * Bugs report on bug-xnee@gnu.org:
       "Bug report: libpanelapplet-2.0" (12/15/2009 11:07 AM)
       "Bug report: No package 'libgnomeui-2.0' found" (12/15/2009 11:03 AM)
       "Configure Error" (12/15/2009 11:07 AM)
       "Error in configure." (12/15/2009 11:09 AM)
       "Building from CVS" (12/17/2009 07:19 PM)

   * Build changes:
       configure bails out when building any gui 
       and no pkg-config installed

       Better help during configure if no gtk, gnomeui found

       Telling user to run configure with --enable-doc option set, 
       when building from CVS (make -f Makefile.cvs)

       New file (README.cvs) to ease up for users building from CVS

Changes in version 3.04 (futsanaj)
==============================

   * Bugs fixed:

       Bad context / RECORD bug fixed:
         https://bugs.freedesktop.org/show_bug.cgi?id=3722
         https://bugs.freedesktop.org/show_bug.cgi?id=20500
         https://bugs.freedesktop.org/show_bug.cgi?id=21971
         https://bugs.launchpad.net/ubuntu/+source/xorg-server/+bug/315456
         https://bugs.launchpad.net/ubuntu/+source/xorg/+bug/379432
 
       Workaround for RECORD problem in Xorg 1.6.0
             recording device events also as delivered 

       Seg faults on Solaris 10 

       Bugs reported on savannah.gnu.org 
       #27850: "Segmentation Fault in print.c"
       #27849: "Another Bug in xnee_resource.c"
       #27848: "Segmentation fault"

   * Doc changes:
       Moved Top node outside of ifinfo statment
       Falling back to one rule for ps and pdf

   * Build changes:
       configure now looks for libgnomeui
       Checking for ps2pdf14 as well as ps2pdf	   


Changes in 3.03
==============================

   * Bugs fixed:
        #23965: Uninitialized variable in cnee
        Demo mode crashes sometimes

        Reported on bug list: 
        Sync doesn't work

        Too quick retype delay bug (see new options)

   * Doc:
        Protocol specification fault corrected
        Added new retype options
        Switched to using texi2pdf texi2ps

   * Test:
        Adjusting to latest swinput (CVS HEAD)
        Adding coverage rules, using gnulib
 
   * New options: 
        --retype-press-delay
        --retype-release-delay 

   * Various:
        cnee, libxnee passes gcc's pedantic mode again

Changes in 3.02
==============================

  Syntax changes:
 
    *  Changed xnee_replay_offset 
       to replay-offset

    *  The following options will not
       accept value in sessions/resource file:
         first-last
         synchronised-replay
         no-synchronise

  New features:
 
    * Version printout changed according
      to new GNU coding standards

  Build changes:

    * Docs built by default

    * New configure options:
         --enable-static-programs (build static programs)

    * Changed configure options:
         --enable-lib  (install libxnee)

    * Fix for X.org releases, recording of deliv events 
      seem need a work around

  Build changes:

     * target now respects DESTDIR
     * possible to choose between static or dynamic binary linking
     * Rule for excluding library install
     * Libtool used
     * Added new pixmap dir
     * Changed icon name to xnee.xpm
     * Docs not built by default
     * Exluding AM_INIT_AUTOMAKE
     * builddoc=false by default

  Bugs fixed:

    * Tries harder to move window

    * Increased move window tries limit to 10

  Doc changes:
     * changed question email address to xnee-devel@gnu.org
  
Changes in 3.0.1
==============================

  New features:
 
  Bugs fixed:
  
    * gnee: About->Close works
    * pnee: About->Close works
    * configure: doc/Makefile.in is built

Changes in 3.0
==============================

  New features:
     * GNU Xnee switches to GPLv3
     * pnee ready for use

  Build changes:

     * Added note on which deb makeinfo is located in for Ubuntu users
     * docs not build by default
     * docs built and shipped with the tar.gz

  Doc changes:

     * Added more notes on xmodmap etc in FAQ
     * Added a brief man page for GNU Xnee
     * docs not build by default
     * docs built and shipped with the tar.gz

  Bugs fixed:

  Various
     * pnee stands for pnee's not even emulating

  Minor updates

Changes in 2.06
==============================

  New features:

     man page for pnee
     man page for gnee

     --check-syntax
       Checks syntax of cli and files. No other action performed.

  Updated Options for cnee

     Short option for recall window position is now:
       -rwp
       (-rcp, is not valid anymore)

  Build changes:

     * configure option for pnee added
	--enable-gnome-applet

     * New script build/test-dist.sh
       verifies dist file

     * New file (README.Debian) for Debian users

     * configure exits if not all doc generating
       programs are found

     * New directory pixmap, used when building gnee or pnee

     * new file: libxnee/include/libxnee/x11_files.h

     * new dirs and files:
            gnee/man/* 
            pnee/man/*

  Doc changes:

     * FAQ entry added on ending recording with Control-C

     * Information on gnee added

     * Information on pnee added

     * Xnee and different keyboard mapping
  Bugs fixed:

     * Replay crashing when window name is empty and using
       recall window position.

     * Buffer overflow error while replaying recorded file

     * #18449 [cnee makes "@" to "q" on german keyboard]

  Various

     * New About window for Gnee

     * Icon added (thanks to Luis Santander and Jeremiah Foster)

     * Solution to crashing X server depends on what server/version 

     * Moved all X11 inclusions to one xnee file (x11_files.h)

  Minor updates

     * Examples (help printout) are updated

Changes in 2.05
==============================

  New Options for cnee

     --recall-window-position

  New features:

     * Handled that windows may be placed differently 
       during replay than during record

  Bugs fixed:

     * Automake fixes for generated files 

     * Xnee records when gnee window is iconified



Changes in 2.04
==============================

  New features:

     * info page for cnee

     * Version number in shell functions (xnee.sh)

     * x,y offset during replay

     * Execution counter added as argument to the program 
       executed by Xnee (using the --exec-* options).

  New Options for cnee

     --infopage (prints texinfo page for cnee)

     --replay-offset

  Build changes:

  Doc changes:

  Bugs fixed:

     * Grabbed (stop) keys are recorded to file

     * Faulty help text on grabbing keys fixed (cnee)

     * If sig received when replaying (and using key grab)
       Xnee messed up X server. Removed grabs from recorded
       session file

  Command line options changes:

  Test updates

     * Added test scripts for test of grab

          cnee/test/scripts/grab/*.sh

  Minor updates

     * Printing program_name to recorded session file


Changes in 2.03
==============================

  New features:

     * Handy shell functions for Xnee primitives

          share/xnee.sh

     * Example shell script added

          examples/simple_bash.sh

  Build changes:

     * autotools/* added to all Makefile.am

     * Makefile.xnee updated to build gnee (not only libxnee and cnee)
       This is an alternative Makefile if use don't want to use configure 
       && make 

     * Added share to dirs to build a Makefile for

     * Examples and handy shell scripts added to dist
          share/xnee.sh
          examples/example1.xns
          examples/simple_bash.sh
       All files are installed to .../share/Xnee/

  Bugs fixed:

      * Memory leaks in libxnee found and fixed

      * Using grab key in gnee twice works causes hanging of X

  Command line options changes:

  Minor updates

       * libxnee/test/libtest.c updated to test grabbing of keys.

       * doc/xnee_example.texi updated with shell script info

Changes in 2.02
==============================

  New features:

  Build changes:

  Bugs fixed:

      * Removed 'recalculation' of screen resolution when distributing 
        device events 

      * Fixed bug distribution option

  Command line options changes:


Changes in 2.01
==============================

  New features:

  Build changes:

      * Documents built by default. If not all progs found, doc is not built 
        after WARNING the user.

  Bugs fixed:

      * Segmentation fault when opening About window fixed.

      * Missing copyright in files 

  Command line options changes:

Changes in 2.0
==============================

  New features:

       * Graphical User Interface (GUI) 

       * Script primitives added 

       * xosd support

       * Characters supported by '--retype--file' option
          a-z,A-Z,0-9,\,#,$,!,&,(,),{,},+,-,<,>,@,_,|
          ....and the comma itself

       * New thresholds:
         events-to-record defaults to -1
         data-to-record defaults to   -1
         time-to-record defaults to   -1

       * Key grabbed (by Xnee) resulting in a successful grab isn't 
         printed to the recorded file.
	

  Bugs fixed:

         * Record/replay multiple screens

  Command line options changes:

        * New options:
           '--data-to-record'
           '--events-to-record'
           '--seconds-to-record'
           '--event-range'
           '--out-file'
           '--err-file'
           '--exec-key'
           '--exec-program'
           '--feedback-none'
           '--feedback-xosd'
           '--feedback-stderr'
           '--store-mouse-pos'

        * Options with new interpretation:
           '--stop-key'
           '--pause-key'
           '--resume-key'
           '--exec-key'
           '--insert-key'
        
        * Obsoleted options:
           '--out'
           '--err'
           '--binary'
           '--everything'
           '--no-expose'
           '--all_events'
           '--print_settings'
           '--first_last'
           '--no_expose'
           '--stop_key'
           '--human_printout'
           '--delivered_event_range'
           '--device_event_range'
           '--error_range'
           '--request_range'
           '--reply_range'
           '--extension_request_major_range'
           '--extension_request_minor_range'
           '--extension_reply_major_range'
           '--extension_reply_minor_range'
           '--loops'
           '--all-events'
           '--no-expose'
           '--everything'


Changes in 1.08
        - new options:
           '--write-settings'      writes a resource file from settings done
           '--mouse'               sets up ranges for all mouse events
           '--keyboard'            sets up ranges for all keynoard events
           '--recorded-resolution' resolution used when recording
           '--replay-resolution'   resolution to use when replaying
           '--no-resolution-adjustment'   Don't use resolution adjustment
           '--speed-percent [percent]'   change the replaying speed
           '--pause-key [k m]'         key+modifier pauses xnee's current action
           '--pause-key [k m]'         key+modifier resume xnee's paused action
           '--insert-key [k m]'        key+modifier inserts a meta mark in the log file
           '--max-threshold [nr]'      sets the maximum threshold during sync
           '--min-threshold [nr]'      sets the maximum threshold during sync
           '--tot-threshold [nr]'      sets the total threshold during sync
           '--retype-file [file]'      retype the contents of file
           '--retype-help '            retype the help printout
        - synchronisation rewritten 

Changes in 1.07
        - version numbering changed (x.yz is used instead of x.y.z)
        - plugin functionality renamed to resource
        - plugin functionality added (plug in dynamic libs)
        - synchronization rewritten
        - force-replay option added
        - replay delay rewritten
        - Xnee can be configured (during configure) to:
          + exclude buffer verbose
        - print functions replaced by function pointers
          in dispatch functions, 
        - Added modifier+key binding to pause, resume 
        
Changes in 1.0.6
        - data names can now be more then 10 chars long ... errrh
        - Xnee can be configured to:
          + exclude verbose mode
          + gcov compilation
          + grpof compilation
        - new or modified options:
          '--print-event-names'   prints all event names and number
          '--print-request-names' prints all request names and number
          '--print-event-names'   prints event name or  number
          '--print-request-names' prints request names or number

Changes in 1.0.6pre1
        - multiple modifiers added
        - data names can be used when setting ranges
        - docs updated with the above changes
        - range setting (when replaying) bug corrected
        - speed increased (removed recording of device event when replying)
        - Xnee is now a GNU package

Changes in 1.0.5
        - Typos corrected in doc/ & README (after GNU review)
        - Fiex parser error (--no_sync ----> --no-sync )
        - Manual corrected (after GNU review)
        - new options added to ease up usage a bit:
           '--print-event-name' 
           '--print-error-name' 
           '--print-reply-name' 
           '--print-request-name' 
           '--print-data-name' 
        - info, manuals updated

Changes in 1.0.4
        - changed printout for --help and --version
        - made ChangeLog what is supposed to be         
          build.sh doesn't copy NEWS to ChangeLog anymore
        - xnee manual is now under FDL
        - xnee developer manual is now under FDL
        - TODO updated with GNU Coding Standard todos
        - doc (texi) files updated with index refs
        - doc (texi) files updated to make info pages nice
        - build_web.sh added to CVS
        - fixed one sigbus & one sigsegv on non-glibc platforms (thanks freeBSD)
                
Changes in 1.0.3
        - fixed parse error (mainor_range  ---> minor_range )
        - switched to CLI options syntax as recommended by the GNU Coding Standards 
        - fixed a seg fault when closing down recording

Changes in 1.0.2
        - stop_key is now correctly parsed (man page updated)
        - CPU consuming calls to XRecordProcessReplies removed
        - Async recording is not used anymore
        - Fixed memory leak (a few bytes when closing down)
        - man page corrected
        - help printout corrected

Changes in 1.0.1
        - Fixed memory leak

Changes in 1.0
        - Added --stop_key option to CLI and plugin files and record file
        - Added --future_clients option to CLI
        - Manual in pdf has moved to Documentation package
        - Manual updated
        - Example session included
        - Source code is documented (using doxygen)
        - man pages are generated from xnee binary
        - Xnee now comes in two packages Program and Documentation

Changes in 0.9
        - new command line options:
                --print_settings
        - xnee reads (and uses) settings from recorded file
        - added texi files (pdf, html, txt manuals)
        - added man page
        - EXAMPLES file updated 
        - redhat specs updated

Changes in 0.9beta
        - ugly printout when using delayed startup removed
        - MANUAL added

Changes in 0.9alpha
        - synchronisation works .... at last  :)
        - removed a lot of duplicated code
        - The following option has been updated
         1) help 
         2) binary 
         3) out "stdout" in plugin scripts is treated  
            as stdout (not creating a file called stdout)
         4) err "stderr" in plugin scripts is treated
            as stderr (not creating a file called stderr)
        - DESCRIPTION, EXAMPLES, FAQ, README, TODO updated
        - DEVELOPMENT added

Changes in 0.8.1
        - fixed a hanging (not on all platforms) xnee when finished replaying
        - fixed dependency to libxnee for the xnee binary in the generated Makefiles
        - fiexd missing newline in help text

Changes in 0.8
        - minor bugfixes
        - copyright years added 
        - the depcomp script have been added. 
        - It compiles and runs on Solaris8 (intel) and Windows98/Cygwin/Xfree86. 
        - The order of libs to be linked has changed. 

Changes in 0.8beta
        - --time  options now works 
        - Pressing Ctrl-C will stop Xnee but __NOT__ remove the recorded file

Changes in 0.8alpha
        - worked around the bug* that crashed the X server when recording
        delivered events.
        
        *) I still do not know where the bug is located (e.g xnee, X, RECORD)


Changes in 0.7.2
        - "plugins / xnee settings" is from now on only called plugin .. sorry about the fuzz
        - Support for RedHat RPM/SRPMS is included is distribution
        - build.sh is extended to build from clean dist to RPMs

Changes in 0.7.1
        - Support for plugins / xnee settings file is corrected

Changes in 0.7
        - Delay works fine 
        - System info printing is back ... never missed it really since replay doesn't use it .. yet
        - Support for plugins / xnee settings file is added


Changes in 0.7alpha_2
        - Xnee can now record delivered events (used FutureClients)
          without crashing
        - First event not recorded (thank to Ton van Vliet)

Changes in 0.7alpha_1
        - Seg. fault on debian fixed
        - Mem fault on OpenBSD fixed
        - Xnee is now (at last) "autoconfed"

